using ClassLibraryTest;
using System.Text.RegularExpressions;

namespace TestsForLibrary
{
    [TestClass]
    public class UnitTest1
    {
        TestL obj = new TestL();
        /// <summary>
        ///          
        /// </summary>
        [TestMethod]
        public void test1CharMas()
        {
            Assert.IsInstanceOfType(obj.perevodVEkvivalent("JHMCM56557C404453".ToCharArray()), typeof(char[]));     
        }

        /// <summary>
        ///          
        /// </summary>
        [TestMethod]
        public void test2NoLetters()
        {
            char[] buf = obj.perevodVEkvivalent("JHMCM56557C404453".ToCharArray());
            Assert.AreEqual(0, buf.Count(x => Char.IsLetter(x)));
        }

        /// <summary>
        ///    toIntArray  
        /// </summary>
        [TestMethod]
        public void test3ReturnNumbers()
        {
            Assert.IsInstanceOfType(obj.toIntArray(obj.perevodVEkvivalent("JHMCM56557C404453".ToCharArray())), typeof(int[]));
        }

        /// <summary>
        ///       
        /// </summary>
        [TestMethod]
        public void test4CheckSum()
        {
            int[] buf = { 1, 8, 4, 3, 4, 5, 6, 5, 5, 7, 3, 4, 0, 4, 4, 5, 3 };
            Assert.AreEqual(5, obj.raschetSum(buf));
        }

        /// <summary>
        ///   vin-  
        /// </summary>
        [TestMethod]
        public void test5CheckVinLength()
        {
            Assert.AreEqual(obj.create_vin().Length, obj.ves.Length);
        }

        /// <summary>
        ///   ,        
        /// </summary>
        [TestMethod]
        public void test6ThrowArgumentException()
        {
            char[] buf = new char[0];
            Action act = () => obj.perevodVEkvivalent(buf);
            Assert.ThrowsException<ArgumentException>(act);
        }

        /// <summary>
        ///          
        /// </summary>
        [TestMethod]
        public void test7ThrowArgumentException1()
        {
            char[] buf = { 'h', 'e', 'l', 'l', 'o', 'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a' };
            Action act = () => obj.toIntArray(buf);
            Assert.ThrowsException<ArgumentException>(act);
        }

        /// <summary>
        ///   ,     
        /// </summary>
        [TestMethod]
        public void test8UnrealControlSum()
        {
            int[] buf = new int[17];
            buf[8] = 1;
            Action act = () => obj.raschetSum(buf, 1);
            Assert.ThrowsException<Exception>(act);
        }

        /// <summary>
        ///   ,       
        /// </summary>
        [TestMethod]
        public void test9UnableToRaschitatSum()
        {
            int[] buf = new int[1000];
            Action act = () => obj.raschetSum(buf);
            Assert.ThrowsException<ArgumentException>(act);
        }

        ///// <summary>
        /////   ,      
        ///// </summary>
        //[TestMethod]
        //public void test10NedopustimiiSymbol()
        //{
        //    string buf = "JHMCO56557C404453";
        //    TestL.vin = buf;
        //    Action act = () => obj.proverkaVin();
        //    Assert.ThrowsException<Exception>(act);
        //}

        /// <summary>
        ///          
        /// </summary>
        [TestMethod]
        public void test11()
        {
            int[] buf = {1,2,3,4,5};
            Action act = () => obj.raschetSum(buf);
            Assert.ThrowsException<ArgumentException>(act);
        }

        /// <summary>
        ///       
        /// </summary>
        [TestMethod]
        public void test12()
        {
            string buf = "WFTNXXGBBNWJ73985";
            Assert.AreNotEqual(obj.raschetSum(obj.toIntArray
                (obj.perevodVEkvivalent(buf.ToCharArray()))),
                buf.ToCharArray()[8]);
        }

        /// <summary>
        ///   ,       vin
        /// </summary>
        [TestMethod]
        public void test13()
        {
            string buf = "hello";
            TestL.vin = buf;
            Action act = () => obj.proverkaVin();
            Assert.ThrowsException<IndexOutOfRangeException>(act);
        }

        //[TestMethod]
        //public void test14()
        //{
        //    string buf = obj.create_vin().ToString();
        //    Regex r = new Regex("^([A-HJ-NPR-Z0-9]{3}[A-HJ-NPR-Z0-9]{5}[0-9X][A-HJ-NPR-Z0-9]{8})$");
        //    Assert.IsTrue(r.IsMatch(buf));
        //}
    }
}